/***************************************************************************
 * Copyright 2000-2014 Nobby Noboru Hirano
 * All rights reserved
 * 
 * Ntools BSD License
 * Version 1.0 March 2005
 *
 * Nobby Noboru Hirano <nobby@ntools.net>
 ****************************************************************************/
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define	__ADDHEADER

#include <sidf.h>
#include <kzh.h>

/**********************************************************************
 * smfi_addheader is for only in mlfi_eom function
 * however plugin for Kuzuha, you are able to use add header function
 * 'kzh_addheader' , compatible such as smfi_addheader.
 * Actual adding header after mlfi_eom execution.
 * It means when execution mlfi_connect and so on return REJECT status,
 * unable to add header even if exec 'kzh_addheader' function.
 *
 * if use in "plugin" source #include this file.
 **********************************************************************/


static int kzh_addheader(SMFICTX *ctx, char *headerf, char *headerv)
{
	ADDHEADER *ahp;
	static ADDHEADER *ohp = NULL;

	struct mlfiPriv *priv = (struct mlfiPriv *)smfi_getpriv(ctx);

	if (priv == NULL)
		return MI_FAILURE;

	if((ahp = calloc(1, sizeof(ADDHEADER))) == NULL) return MI_FAILURE;
	if(priv->addheader == NULL) priv->addheader = ahp;
	else ohp->fwd = ahp;

	ahp->headerf = strdup(headerf);
	ahp->headerv = strdup(headerv);
	ohp = ahp;

	return MI_SUCCESS;
}
